\section{Dynamic bindings vs. unwind-protect}

\subsection{Status}

We chose to make dynamic bindings and an unsafe
call-with-escape-continuation primitive, instead of making
unwind-protect and ``raw'' thread-local variables primitive. The
latter would require trickier control flow which hops between
Utena and host code frequently, and the former can have
both a safe call-with-escape-continuation and unwind-protect
implemented using a portable shim.

\subsection{Context}

In a single-threaded system with a call-with-escape-continuation
primitive, unwind-protect and dynamic variables can be used to
implement each other. unwind-protect implements dynamic
variables by resetting the value of a global variable upon leaving
the extent of the unwind-protect; dynamic variables implement
unwind-protect by recording a chain of handlers, and
wrappers over continuations scan through the chain upon
unwinding \cite{constraining-control}.%
\footnote{Our implementation in H{\aa}{\aa}den Two is closer to that
  in chapter 5 of \cite{dybvig}. Dybvig also assumes a
  single-threaded system, using a single global variable to store
  handlers, whereas we use a dynamic variable to store
  handlers.}

\subsection{Possible solutions}

Earlier versions of the Utena specification began specifying the
semantics of an unwind-protect primitive, which required
adding handlers to the call stack and required the process of
unwinding to manage to continue unwinding after calling a
handler function. We believe Utena should also have dynamic
variables exposed to the user, so having handlers have another
form of dynamic variables was unappealing.

In a multi-threaded system, thread-local variables are also
required in order to implement dynamic variables, complicating
the implementation of dynamic variables by unwind-protect.
Such an implementation also has to mutate a slot in some
global object, which may confuse optimising compilers of Utena
code; in particular, the stack-like behaviour of bindings is
obfuscated.

The least effort to implement dynamic variables as a primitive
requires passing a dynamic environment between message sends,
like an implicit argument to every message send. (Indeed
a similar construct to dynamic variables is named
``implicit parameters'' in Haskell.) This is represented in the
semantics as another register in the state of the abstract machine.

Thus it seems having the dynamic environment being a primitive is
easier than having unwind-protect be primitive. The dynamic
environment is more passive in behaviour, and requires less
mutation that an implementation might need to see through.